/**
 *	@file	fname.h
 *	@brief	t@C̏.
 *	@author tenk* (Masashi Kitamura)
 *	@note
 *	-	c/c++ p.
 *	-	Public Domain Software
 */
#ifndef FNAME_INCLUDED
#define FNAME_INCLUDED


// t@C̃TCY. p̃obt@p.
// fname.c/hł́Afname_relativePath??݂̂A̒lg.(͎QƂȂ)
#ifndef FNAME_MAX_PATH
 #if defined _MAX_PATH
  #define FNAME_MAX_PATH 		_MAX_PATH		///< ʏ̃pX̒.
 #else
  #define FNAME_MAX_PATH 		1024			///< ʏ̃pX̒. ()
 #endif
#endif

// win̏ꍇ ň͖0x8000ApȂȒlɌ炵Ă.
#ifndef FNAME_MAX_URL
 #define FNAME_MAX_URL			(6U*4*FNAME_MAX_PATH)	///< urlƂĈꍇ̃pXTCY.
#endif


#ifdef UNICODE	// wcharT Ή.
 #if defined __cplusplus
  #define FNAME_CHAR			wcharT
 #elif defined _WIN32
  #define FNAME_CHAR			unsigned short
 #else
  #define FNAME_CHAR			wcharT
 #endif
 #define FNAME_LEN(s)			wcslen(s)
#else			// char x[X.
 #define FNAME_CHAR				char
 #define FNAME_LEN(s)			strlen(s)
#endif

#if defined _WIN32 || defined _DOS || defined _MSDOS
#include <tchar.h>
#define FNAME_SEP_CHR			_T('\\')
#define FNAME_SEP_STR			_T("\\")
#else
#define FNAME_SEP_CHR			'/'
#define FNAME_SEP_STR			"/"
#endif


// c++const΍.
#ifdef __cplusplus				// c++̏ꍇA|C^݂̂̊֐const,constł.
#define FNAME_CCHAR				FNAME_CHAR		// ̂߁A{́Aconst֐ɂ.
#else							// c̏ꍇ͕WCuɂ킹 constŖ߂l const ɂ.
#define FNAME_CCHAR				const FNAME_CHAR
#endif


#ifdef __cplusplus
extern "C" {
#endif

#ifndef _WIN32	// linux/unixnLANGlꍇ, C̏ꍇ͍ŏɌĂяo. c++̏ꍇ͎ōs.
void		 fname_init();
void		 fname_term();
#endif

int			 fname_isAbs(const FNAME_CHAR* path);									///< ΃pXۂ(hCu̗L͊֌WȂ)
int			 fname_haveDrive(const FNAME_CHAR* path);								///< hCuĂ邩. (file:  http:hCu)

unsigned	 fname_adjust_size(const FNAME_CHAR* str, unsigned size);				///< (Ȃׂ󂳂Ȃ)sizeȓ̕Ԃ.
FNAME_CHAR*  fname_cpy(FNAME_CHAR dst[], unsigned sz, const FNAME_CHAR* src);		///< t@C̃Rs[.
FNAME_CHAR*  fname_cat(FNAME_CHAR dst[], unsigned sz, const FNAME_CHAR* src);		///< t@C̘A.

FNAME_CHAR*  fname_baseName(FNAME_CCHAR *adr);										///< t@CpX̃fBNgt@C̈ʒuԂ.
FNAME_CHAR*  fname_ext(FNAME_CCHAR *name);											///< gq̈ʒuԂ.
FNAME_CHAR*  fname_skipDrive(FNAME_CCHAR *name);									///< hCuXLbvʒuԂ.
FNAME_CHAR*  fname_skipDriveRoot(FNAME_CCHAR* name);								///< hCuƃ[gw蕔XLbvʒuԂ.

FNAME_CHAR*	 fname_delExt(FNAME_CHAR name[]);										///< gq폜.
FNAME_CHAR*	 fname_getNoExt(FNAME_CHAR dst[], unsigned sz, const FNAME_CHAR *src);	///< gqOO擾.
FNAME_CHAR*	 fname_getBaseNameNoExt(FNAME_CHAR d[],unsigned sz,const FNAME_CHAR *s);///< fBNgƊgqOO擾.

FNAME_CHAR*  fname_setExt(FNAME_CHAR dst[], unsigned sz, const FNAME_CHAR* src, const FNAME_CHAR *ext);			///< gqAext ɕύX.
FNAME_CHAR*  fname_setDefaultExt(FNAME_CHAR dst[], unsigned sz, const FNAME_CHAR* src, const FNAME_CHAR *ext);	///< gqȂ΁Aext ǉ.

FNAME_CHAR*  fname_join(FNAME_CHAR dst[],unsigned sz,const FNAME_CHAR *dir,const FNAME_CHAR *nm);				///< fBNgƃt@C̘A.

FNAME_CHAR*  fname_getDir(FNAME_CHAR dir[], unsigned sz, const FNAME_CHAR *nm);		///< fBNg̎擾.
FNAME_CHAR*  fname_getDrive(FNAME_CHAR drv[], unsigned sz, const FNAME_CHAR *nm);	///< hCu擾.
FNAME_CHAR*  fname_getDriveRoot(FNAME_CHAR dr[],unsigned sz,const FNAME_CHAR *nm);	///< hCu擾.

FNAME_CHAR*  fname_checkLastSep(FNAME_CCHAR* dir);									///< Ō\/΂̃AhXȂNULLԂ.
FNAME_CHAR*  fname_delLastSep(FNAME_CHAR dir[]);									///< ̍Ō \  / ΍폜.
FNAME_CHAR*  fname_addSep(FNAME_CHAR dst[], unsigned sz);							///< ̍Ō \ / ȂΒǉ.

FNAME_CHAR*  fname_toUpper(FNAME_CHAR filename[]);									///< SpQoCgڂl strupr.
FNAME_CHAR*  fname_toLower(FNAME_CHAR filename[]);									///< SpQoCgڂl strlwr.
FNAME_CHAR*  fname_backslashToSlash(FNAME_CHAR filePath[]);							///< filePath \  / ɒu.
FNAME_CHAR*  fname_slashToBackslash(FNAME_CHAR filePath[]);							///< filePath /  \ ɒu.

FNAME_CHAR*  fname_fullpath(FNAME_CHAR fullpath[], unsigned sz, const FNAME_CHAR* path, const FNAME_CHAR* curDir);		///< tpX. osˑ.
FNAME_CHAR*  fname_fullpathSL(FNAME_CHAR fullpath[], unsigned sz, const FNAME_CHAR* path, const FNAME_CHAR* curDir);	///< tpX. / .
FNAME_CHAR*  fname_fullpathBS(FNAME_CHAR fullpath[], unsigned sz, const FNAME_CHAR* path, const FNAME_CHAR* curDir);	///< tpX. \ .
FNAME_CHAR*  fname_relativePath(FNAME_CHAR relPath[], unsigned sz, const FNAME_CHAR* path, const FNAME_CHAR* curDir);	///< ΃pX. osˑ.
FNAME_CHAR*  fname_relativePathSL(FNAME_CHAR relPath[], unsigned sz, const FNAME_CHAR* path, const FNAME_CHAR* curDir);	///< ΃pX. / .
FNAME_CHAR*  fname_relativePathBS(FNAME_CHAR relPath[], unsigned sz, const FNAME_CHAR* path, const FNAME_CHAR* curDir);	///< ΃pX. \ .

int   		 fname_cmp(const FNAME_CHAR* l, const FNAME_CHAR* r);					///< t@C̑召r.
int   		 fname_n_cmp(const FNAME_CHAR* l, const FNAME_CHAR* r, unsigned len);	///< t@Cn召r.
FNAME_CHAR*	 fname_equLong(FNAME_CCHAR* fname, const FNAME_CHAR* baseName);			///< fnamebaseNameŎn܂Ă邩ۂ.
int 		 fname_matchWildCard(const FNAME_CHAR* pattern, const FNAME_CHAR* str);	///< ChJ[h(*?)r. }b`^.

/// R}hCA;؂̃̕pXw肩APvf擾.
FNAME_CHAR*  fname_scanArgStr(FNAME_CHAR arg[],unsigned sz,const FNAME_CHAR *str, unsigned sepChr);

#ifdef __cplusplus
}
#endif


#ifdef __cplusplus	// ΍.
inline const FNAME_CHAR* fname_baseName(const FNAME_CHAR *p)		{ return fname_baseName((FNAME_CHAR*)p); }
inline const FNAME_CHAR* fname_ext(const FNAME_CHAR *name)			{ return fname_ext((FNAME_CHAR*)name); }
inline const FNAME_CHAR* fname_skipDrive(const FNAME_CHAR *name)	{ return fname_skipDrive((FNAME_CHAR*)name); }
inline const FNAME_CHAR* fname_skipDriveRoot(const FNAME_CHAR *name){ return fname_skipDriveRoot((FNAME_CHAR*)name); }
inline const FNAME_CHAR* fname_checkLastSep(const FNAME_CHAR* dir)	{ return fname_checkLastSep((FNAME_CHAR*)dir); }
inline const FNAME_CHAR* fname_equLong(const FNAME_CHAR* fname, const FNAME_CHAR* baseName) { return fname_equLong((FNAME_CHAR*)fname, baseName); }

inline FNAME_CHAR*	fname_scanArgStr(FNAME_CHAR arg[],unsigned sz,const FNAME_CHAR *str) { return fname_scanArgStr(arg,sz,str,_T(' ')); }
inline FNAME_CHAR*	fname_setExt(FNAME_CHAR name[], unsigned sz, const FNAME_CHAR *ext) { return fname_setExt(name, sz, name, ext); }
inline FNAME_CHAR*	fname_setDefaultExt(FNAME_CHAR name[], unsigned sz, const FNAME_CHAR *ext) { return fname_setDefaultExt(name, sz, name, ext); }
#endif



#endif		// FNAME_H.
